#
#   Comproveu que els vostres fitxers (el A11.txt):
#      a) tenen una capalera a la primera linea "x"
#   "x"
#    0.5390
#    0.0572
#    1.6684
#    ...
#      b) estan codificats UTF-8 o ANSI
#   Per comprovar a) b), entreu obriu el fitxer amb el Notepad editor del Windows. 
#   Afegiu la capalera "x" si cal.
#   Feu "Save as". En la finestra que apareixer comproveu el camp "Encoding" i poseu-lo a ANSI o UTF-8
#
setwd("D:/users/esteve/G/doce/GIE-UB-UPC/TCiS/apunts/laboratori/P2-R")  # Ull! no admet backslash "\" !!!
dd <- read.table("A11.txt", header=TRUE, as.is=T)
sample <- dd$x
hist(sample,20)


#sample<-rgamma(240,shape=1,scale=16)        # Es genera una mostra artificialment. 240 elements. CANVIAR-HO D'ACORD AMB LA PRÀCTICA
summary(sample)                             # Es treuen estadístiques bàsiques
mm<-mean(sample)                            # mitjana
samplerate<-1/mm                            # com que la mostra prové d'una exponencial convé calcular el seu paràmetre
par(mfrow=c(1,2))                           # Es configura com serà el display. 
                                            # En aquest cas serà dues columnes 1 fila (hi podra cablre dos gràfics paral·lels)
#hist(sample,breaks=25,col="yellow",main="Equal interval length ... ")
hist(sample,freq=FALSE,breaks=25,col="yellow",main="Equal interval length ... ") # opcio freq=FALSE canvia l'escala y a densitats i no a freqüencies.
curve(dgamma(x,shape=1,scale=16.398179),col=2,add=T) # dibuixa la corba de la distribució contra la que es fa el test
1/0.04
sequence<-seq(0,1,by=0.04)                  # Crea la sequència de punts de tall sobre el [0,1] amb distància entre punts de 0.04
sequence                                    # la mostra

# H0: Exponencial lambda = 1/16             
perdist<-qexp(sequence,rate=1/16)           # Crea la sequència de punts de tall sobre el eix t, [0,infty] marcada per la Funció de distribció inversa de la dist. H0
perdist
perdist[26]<-80                             # El darrer punt qe seria infinit es canvia a un valor raonable
perdist
hist(sample,freq=FALSE,breaks=perdist,col="green",main="Length defined by percentiles  ... ") # Exemple de histograma per percentils
curve(dgamma(x,shape=1,scale=mm),col=2,add=T)              # S'hi solapa una corba
# Chi squared test
dsample<-cut(sample,breaks=perdist,include.lowest = T)    
dsample
table(dsample)
summary(dsample)
iobs<-as.vector(table(dsample))            # Obs in the groups defined by nb intervals-percentiles
pexp<-as.vector(rep(1/25,25))              # Expected probability for each groups: sample size/nb intervals
iexp<-240*pexp                             # VALOR ESPERAT D'OBSERVACIONS
iobs                                       # VALOR DE Nº D'OBSERVACIONS EN CADA INTERVAL
iexp
X2<-sum(((iobs-iexp)^2)/iexp);X2           # CÀCLCUL DE L'ESTADISTIC DE X2
chisq.test( sample, "pweibull", shape= 2, scale=1 ) #EXEMPLE QUE NO FUNCIONA
1-pchisq(X2,23)                             # pvalue = P(H0)=P(Shiq(23)>X2)
chisq.test( iobs,p=pexp )                 # EXEMPLE QUE SI FUNCONA

barplot(table(dsample),main="Observed counts",col="green") # ES DIBUIXA UN DIAGRAMA DE BARRES QUE DONA IDEA DE LA REGULARITAT DEL Nº D'OBSERVACIONS DISTRIBUÏT SOBRE CADA INTERVAL
abline(h=240/25,col="red",lwd=2,lty=2)    # ES superposa una línia d'alçada Nº ESPERAT D'OBSERVACIONS PER INTERVAL
